#!/opt/local/bin/perl -w

use PDL;
use PGPLOT;
use strict;

my @xel_off;
my @el_off;
my ($az, $el, $meas_xel_off, $meas_el_off);
my @az_a;

my @el_a;
my @meas_el_off;
my @meas_xel_off;
my @rows;
my @offsets;
my @new_off_xel = ();
my @new_off_el= ();

# input model
my @P = [];
$P[0] = 0;
$P[1] = -0.4953; 
$P[2] = 0.03;	 
$P[3] = 0.2196;	 
$P[4] = -0.0252; 
$P[5] = -0.0363; 
$P[6] = 0;  
$P[7] = 0.0435;
$P[8] = -0.1753;
$P[9] = -0.0083;
#$P[0] = 0;
#$P[1] = -0.071;
#$P[2] = -0.376;
#$P[3] = 0.023;
#$P[4] = -0.013;
#$P[5] = -0.016;
#$P[6] = 0;
#$P[7] = -0.096;
#$P[8] = 0.032;
#$P[9] = -0.004;
#$P[1] = -0.36;
#$P[2] = 0;
#$P[3] = 0;
#$P[4] = 0.0007;
#$P[5] = 0.0082;
#$P[6] = 0;
#$P[7] = -0.176;
#$P[8] = 0;
#$P[9] = 0;

my $file = $ARGV[0];

  open (FILE, "$file") or die "Can't open $file: $!";
my ($az1, $el1);
  while(<FILE>) {
    if (!/^#/) {
      chomp;
      ($az1, $el1, $meas_xel_off, $meas_el_off) = split(' ');
#      print "az = $az  ($az, $el, $meas_xel_off, $meas_el_off)\n";
      $az = $az1- (xel_off(\@P, $az1, $el1)/cos(deg_to_rad($el1)));
      $el = $el1 - el_off(\@P, $az1, $el1);
      push @az_a, $az;
      push @el_a, $el;
      push @meas_xel_off, $meas_xel_off;
      push @meas_el_off, $meas_el_off;
      push @xel_off, $meas_xel_off + xel_off(\@P, $az, $el);
      push @el_off, $meas_el_off + el_off(\@P, $az, $el);
#      print "$az_a[$#az_a]\t $el_a[$#az_a]\t $meas_xel_off[$#az_a]\t $meas_el_off[$#az_a]\t $xel_off[$#az_a]\t $el_off[$#az_a]\n";
      # build matrix rows for @offsets
      push @offsets, [ $xel_off[$#az_a] ];
      push @offsets, [ $el_off[$#az_a] ];

      # build the matrix rows for Phi
      #dxEL
      push @rows, [1, cos(deg_to_rad($el)), sin(deg_to_rad($el)), sin(deg_to_rad($el))*cos(deg_to_rad($az)) ,  
		   sin(deg_to_rad($el))*sin(deg_to_rad($az)), 0, 0, 0];
      #dAZ
      push @rows, [0, 0, 0, -1.0 * sin(deg_to_rad($az)), cos(deg_to_rad($az)), 1, cos(deg_to_rad($el)), 1.0/tan(deg_to_rad($el))];

    }
  }
  close(FILE);

my $moff = pdl @offsets;
my $mphi = pdl @rows;
my $mphi1 = pdl @rows;
my $mphi2 = pdl @rows;
my $mphi3 = pdl @rows;
my $mphi4 = pdl @rows;
my $mphi5 = pdl @rows;
my $mphi6 = pdl @rows;

#print $moff;
#print $mphi;

#print "1----------------\n";
#print transpose($mphi1);
#print "2----------------\n";
#print transpose($mphi2) x $mphi3;
#print "3----------------\n";
#print inv(transpose($mphi4) x $mphi5);
#print "4----------------\n";
#print ((inv(transpose($mphi) x $mphi)) x transpose($mphi));
#print "5----x------------\n";

my $out = (((inv(transpose($mphi) x $mphi)) x transpose($mphi)) x $moff);
my @out = (0,0,0,0,0,0,0,0,0,0);
@out = (list $out);
my @P_new = [];
$P_new[0] = 0;
$P_new[1] = $out[0];
$P_new[2] = $out[1];
$P_new[3] = $out[2];
$P_new[4] = $out[3];
$P_new[5] = $out[4];
$P_new[6] = 0;
$P_new[7] = $out[5];
$P_new[8] = $out[6];
$P_new[9] = $out[7];

#parameters in use until 03:30 UT 2010 May 12
#$P_new[0] = 0;
#$P_new[1] = -0.071;
#$P_new[2] = -0.376;
#$P_new[3] = 0.023;
##$P_new[4] = -0.013;
#$P_new[5] = -0.016;
#$P_new[6] = 0;
#$P_new[7] = -0.096;
#$P_new[8] = 0.032;
#$P_new[9] = -0.004;

my ($a1,$a2,$a3,$a4,$b1,$b2,$b3,$b4);

$a1 = $ARGV[1]+(xel_off(\@P_new, $ARGV[1], $ARGV[2])/cos(deg_to_rad($ARGV[2])));
$a2 =  (xel_off(\@P_new, $ARGV[1], $ARGV[2])/cos(deg_to_rad($ARGV[2])));
$a3 =  $ARGV[2]+el_off(\@P_new, $ARGV[1], $ARGV[2]);
$a4 = el_off(\@P_new, $ARGV[1], $ARGV[2]);

$b1 = $ARGV[1]+(xel_off(\@P, $ARGV[1], $ARGV[2])/cos(deg_to_rad($ARGV[2])));
$b2 =  (xel_off(\@P, $ARGV[1], $ARGV[2])/cos(deg_to_rad($ARGV[2])));
$b3 =  $ARGV[2]+el_off(\@P, $ARGV[1], $ARGV[2]);
$b4 = el_off(\@P, $ARGV[1], $ARGV[2]);



printf "\nNew model \nAz, %.4f\t%.4f\t",$a1 ,$a2;
printf "El, %.4f\t%.4f\n\n\n",$a3,$a4 ;

printf "\nOld model\nAz, %.4f\t%.4f\t",$b1,$b2;
printf "El, %.4f\t%.4f\n\n\n", $b3, $b4;

printf "\nNew - Old model\nAz, %.4f\t%.4f\t",$a1-$b1,$a2-$b2;
printf "El, %.4f\t%.4f\n\n\n", $a3-$b3, $a4-$b4;


#die;
printf "P1 = %.5f\nP2 = %.5f\nP3 = %.5f\nP4 = %.5f\nP5 = %.5f\nP7 = %.5f\nP8 = %.5f\nP9 = %.5f\n", $P_new[1], $P_new[2], $P_new[3], $P_new[4], $P_new[5], $P_new[7], $P_new[8], $P_new[9];
my $i;
for ($i = 0; $i <= $#az_a; $i++) {
  # Calculate the new correction at the observed az,el
  #printf "%f\t", xel_off(\@out, $az_a[$i], $el_a[$i]);
  #printf "%f\n\n", el_off(\@out, $az_a[$i], $el_a[$i]);
  # subtract this from the observed offset
  $new_off_xel[$i] = xel_off(\@P_new, $az_a[$i], $el_a[$i]) - $xel_off[$i];
  $new_off_el[$i]= (el_off(\@P_new, $az_a[$i], $el_a[$i]) - $el_off[$i]);
#  print "$i\t$new_off_xel[$i] $xel_off[$i] \t$new_off_el[$i]\t $el_off[$i]\n";
}
my $j;
pgbegin(0,"/xs",1,1);
pgask(1);
pgsvp(0.1,0.9,0.1,0.9);
#pgswin(0,90,-0.2,0.2);
pgswin(0.0,90,-0.5,0.5);
for ($j = -180; $j <= 180; $j+=20) {
  pgmove(5,el_off(\@P,$j,5));
  for ($i = 5; $i<90;$i++) {
    pgdraw($i,el_off(\@P,$j,$i));
  }
}
pgsci(2);
for ($j = -180; $j <= 180; $j+=20) {
  pgmove(5,el_off(\@P_new,$j,5));
  for ($i = 5; $i<90;$i++) {
    pgdraw($i,el_off(\@P_new,$j,$i));
  }
}
pgsci(6);
for ($j = -180; $j <= 180; $j+=20) {
  pgmove(5,(el_off(\@P_new,$j,5)-el_off(\@P,$j,5)));
  for ($i = 5; $i<90;$i++) {
    pgdraw($i,el_off(\@P_new,$j,$i)-el_off(\@P,$j,$i));
  }
}
pgsci(1);
for ($i = 0; $i <= $#el_a; $i++) {
  pgsci(1);
  pgpt1($el_a[$i], $el_off[$i], 2);
  pgsci(3);
  pgpt1($el_a[$i], $meas_el_off[$i], 2);
}
  pgsci(1);
pgbox('BCNST', 0.0, 0, 'BCNST', 0.0, 0);
pglab("EL","Offset","white = input model, red = new model, purple = new - input model");
pgend();

pgbegin(0,"?",1,1);
pgpap(0,90/360);
pgask(1);
pgsvp(0.1,0.9,0.1,0.9);
#pgswin(0,90,-0.2,0.2);
pgswin(-180,180,0.0,90);
my @y = @el_a;
my $scal = 100;
pgbox('BCNST', 0.0, 0, 'BCNST', 0.0, 0);
for ($i = 0; $i <= $#az_a; $i++) {
  pgsci(1);
  pgpt1($az_a[$i], $el_a[$i], 2);
  pgsci(3);
  pgmove($az_a[$i], $el_a[$i]);
  pgdraw($az_a[$i]+($scal*$meas_xel_off[$i]), $el_a[$i]+($scal*$meas_el_off[$i]));
  pgsci(5);
  pgmove($az_a[$i], $el_a[$i]);
  pgdraw($az_a[$i]+($scal*$new_off_xel[$i]), $el_a[$i]+($scal*$new_off_el[$i]));
}

print "Stats with current solution\n";
my ($mean,$rms) = get_mean_rms(\@meas_xel_off,$#az_a);
printf "XEl offsets: Mean = %f, RMS = %f\n",$mean,$rms;
($mean,$rms) = get_mean_rms(\@meas_el_off,$#az_a);
printf "El offsets: Mean = %f, RMS = %f\n",$mean,$rms;

print "Stats with new solution\n";
($mean,$rms) = get_mean_rms(\@new_off_xel,$#az_a);
printf "XEl offsets: Mean = %f, RMS = %f\n",$mean,$rms;
($mean,$rms) = get_mean_rms(\@new_off_el,$#az_a);
printf "El offsets: Mean = %f, RMS = %f\n",$mean,$rms;
pgsci(2);
#$scal = 50;
my $j;
for ($i = -180; $i <= 180; $i+=20) {
  for ($j = 5; $j <=85; $j+=10) {
    pgpt1($i,$j,5);
    pgmove($i,$j);
#    pgdraw($i+($scal*xel_off(\@P_new, $i, $j)), $j+(($scal*el_off(\@P_new, $i, $j))));
    pgdraw( $i+ 
	    ($scal*(xel_off(\@P,$i,$j)-xel_off(\@P_new,$i,$j))), 
	    $j+
	    ($scal*(el_off(\@P, $i, $j)-el_off(\@P_new,$i,$j)))
	  );
  }
}
#pgpt($#az_a, \@az_a, \@y, 1);
pgsci(1);
pglab("Az","El","Red = new model w.r.t old model, green = observations, blue = residuals (mdeg x 100)");
pgend();
pgbegin(0,"?",1,1);
pgpap(0,1);
pgsfs(2);
  pgswin(-0.2, 0.2, -0.2, 0.2);
pgcirc(0,0,0.078);
  pgsci(5);
  pgsls(1);
  pgpt($#meas_xel_off+1,\@meas_xel_off,\@meas_el_off, 1);
  pgsci(2);
  pgsls(1);
#print "$#new_off_xel\n";
for ($i = 0; $i <= $#new_off_el; $i++) {
#  print "$i $new_off_el[$i]\n";
  pgpt1($new_off_xel[$i], $new_off_el[$i], 2);
}
#pgpt1($new_off_xel[0], $new_off_el[0], 1);
#  pgpt($#new_off_xel+1,\@new_off_xel, \@new_off_el, 1);
#print "  pgpt(1,$new_off_xel[0], $new_off_el[0], 1);\n";
  pgsci(1);
  pgsls(1);
  pgbox('BCNST', 0.0, 0, 'BCNST', 0.0, 0);
pglab("XEl offset (deg)", "EL offset (deg)", "Blue = old model, Red = new model, Circle = beam FWHM @ 9.1 GHz");
pgend();

pgbegin(0,"?",1,1);

pgswin(0, 90, -0.2, 0.2);
pgsci(5);
pgsls(1);
for ($i = 0; $i <= $#new_off_el; $i++) {
# print "$i $new_off_el[$i]\n";
  pgsci(2);
  pgpt1($el_a[$i], $new_off_el[$i],17);
  pgsci(5);
  pgpt1($el_a[$i], $meas_el_off[$i], 3);
  pgsci(2);
  pgpt1($el_a[$i], $new_off_xel[$i], 16);
  pgsci(5);
  pgpt1($el_a[$i], $meas_xel_off[$i], 2);
}
pgsci(1);
  pgbox('BCNST', 0.0, 0, 'BCNST', 0.0, 0);
pgend();


#$m = mpdl [[1,2,3],[4,5,6]];
#$m = PDL::Matrix->pdl([[1,2,3],[4,5,6]]);
#$m = msequence(4,3);
#print $m;

sub refrac_corr {
  my ($el) = @_;
  my $cor = (0.0019279 + (1.02/tan(deg_to_rad($el+(10.3/($el+5.1))))))/60;
  return ($cor);
}

sub xel_off {
  my ($pref, $az, $el) = @_;
#  print " ($pref, $az, $el)\n";
  my @p = @$pref;
  my $dxel = $p[1] + 
    ($p[2]*cos(deg_to_rad($el))) +
    ($p[3]*sin(deg_to_rad($el))) +
    ($p[4]*sin(deg_to_rad($el))*cos(deg_to_rad($az))) +
    ($p[5]*sin(deg_to_rad($el))*sin(deg_to_rad($az)));
  return($dxel);

}

sub el_off {
  my ($pref, $az, $el) = @_;
  my @p = @$pref;
  my $del = (-1.0 * $p[4] * sin(deg_to_rad($az))) +
    ($p[5] * cos(deg_to_rad($az))) +
    $p[7] +
    ($p[8] * cos(deg_to_rad($el))) +
    ($p[9]/tan(deg_to_rad($el)));
  return ($del);
}


sub deg_to_rad {
  my ($deg) = @_;
#  print "deg_to_rad $_\n";
  my $pi = 3.14159265358979;
  return(($deg/180) * $pi);
}

#sub tan  { 
## return(sin($_) / cos($_));
#}
sub numerically { $a <=> $b; }
#-------------------------------------------------------------------------

sub get_mean_rms {
  my ($vref, $n) = @_;
  my @v = @$vref;
  my $mean;
#  printf "nv = %d, n = %d, mean = %f\n",$#v,$n,$mean;
  my $i;
  my $sum = 0;
  for ($i = 0; $i < $n; $i++) {
    $sum = $sum + $v[$i];
  }
  $mean = $sum/$n;
  $sum = 0;
  for ($i = 0; $i < $n; $i++) {
    $sum = $sum + ($v[$i] - $mean)**2;
#    printf "%d %f %f\n",$i,$sum,($v[$i] - $mean)**2;
  }
  my $rms = sqrt($sum/$n);
  return ($mean, $rms);
}
